=begin

  rbbr.rb - Ruby Meta-Level Information Browser

  $Author: mutoh $
  $Date: 2003/09/06 18:43:46 $

  Copyright (C) 2000-2001 Hiroshi Igarashi <iga@ruby-lang.org>

  This program is free software.
  You can distribute/modify this program under
  the terms of the Ruby Distribute License.

=end

require 'rbbr/ui/gtk'

module RBBR
  VERSION = "0.4.0"

  if ENV['LANG'] =~ /ja_JP/
    ICONV_SRC_CHARSET = "EUC-JP"
  else
    ICONV_SRC_CHARSET = "C"
  end    
  
  module_function
  def conv_utf8(str)
    ret = str
    begin
      if ICONV_SRC_CHARSET != "C"
        ret = GLib.convert(str, "UTF-8", ICONV_SRC_CHARSET)
      end
    rescue RuntimeError
      if $DEBUG
        print "can't converted from #{ICONV_SRC_CHARSET} to UTF-8\n"
        print "String = #{str}\n"
      end
    end
    ret
  end
end
