=begin

  rbbr/doc/refe.rb - Document Referring with ReFe

  $Author: mutoh $
  $Date: 2003/08/07 17:30:55 $

  Copyright (C) 2002 Ruby-GNOME2 Project

  Copyright (C) 2001 Hiroshi Igarashi <iga@ruby-lang.org>

  This program is free software.
  You can distribute/modify this program under
  the terms of the Ruby Distribute License.

=end

require 'rbbr/doc'
require 'refe/database'
require 'refe/info'

module RBBR
  module Doc

    class ReFe < Database
=begin
Currently, This adopter require ReFe 0.7.1 or later.
=end
      def initialize
	super()
	@db = ::ReFe::Database.new(::ReFe::REFE_DATA_DIR, true)
      end

      def lookup_class( klass )
        begin
          doc = @db.class_document
          RBBR::conv_utf8(doc[klass])
        rescue
          raise LookupError, $!.message
        end
      end
      
      def lookup_module( modul )
        raise LookupError, "module/class is not supported"
      end

      def lookup_const( const )
	raise LookupError, "constant is not supported"
      end
      
      def lookup_method( method )
        begin
          doc = @db.method_document
          ret = doc[method].split("\n").collect!{ |line|
            if /^\s{4}/ =~ line
              $'
            else
              line
            end
          }.join("\n")
          RBBR::conv_utf8(ret)
        rescue
          raise LookupError, $!.message
        end
      end

      def info
        "ReFe #{::ReFe::Version}"
      end

      MultiDatabase::DatabaseList << self

    end

  end
end
