=begin

  rbbr/ui/gtk/constlist.rb 

  $Author: mutoh $
  $Date: 2003/09/08 17:37:03 $

  Copyright (C) 2002,2003 Ruby-GNOME2 Project

  Copyright (C) 2000-2002 Hiroshi Igarashi <iga@ruby-lang.org>

  This program is free software.
  You can distribute/modify this program under
  the terms of the Ruby Distribute License.
=end

module RBBR
module UI
module GTK
  class ConstantList < Gtk::TreeView
    include Observable

    def initialize
      @model = Gtk::TreeStore.new(String, String)
      super(@model)
      
      renderer = Gtk::CellRendererText.new
      column = Gtk::TreeViewColumn.new("Name", renderer, {:text => 0})
      column.sort_column_id = 0
      append_column(column)
      column = Gtk::TreeViewColumn.new("Value", renderer, {:text => 1})
      column.sort_column_id = 1
      append_column(column)
      
      selection.mode = Gtk::SELECTION_SINGLE
      selection.signal_connect('changed') do |e|
        iter = selection.selected
        changed
        notify_selection(@modul, iter) if iter
      end

      set_rules_hint(true)
    end
    
    def update(modul)
      freeze_notify
      @model.clear
      modul.constants_at.each{|name|
        const = modul.const_get(name)
        if const.kind_of? GLib::Enum or const.kind_of? GLib::Flags
          #ignore
        else
          if const.class == Class
            if const < GLib::Enum or const < GLib::Flags
              iter = append([name, ""])
              modul.constants_at.sort.each{|child_name|
                child_const = modul.const_get(child_name)
                if child_const.kind_of? const
                  append([child_name, child_const.nick], iter)
                end
              }
              expand_row(iter.path, true)
            end
          elsif not const.is_a? Module
            append([name, const.inspect])
          end
        end
      }
      thaw_notify
      @modul = modul
    end
    
    def append(data, parent_iter = nil)
      iter = @model.append(parent_iter)
      data.each_index do |cnt|
        iter.set_value(cnt, data[cnt])
      end
      iter
    end

    def notify_selection(modul, iter)
      notify_observers(modul, [iter.get_value(0), '::'])
    end
  end
    
end;end;end
