=begin

  rbbr/ui/gtk/moduledisplay.rb 

  $Author: mutoh $
  $Date: 2003/08/02 16:02:12 $

  Copyright (C) 2002,2003 Ruby-GNOME2 Project

  Copyright (C) 2000-2002 Hiroshi Igarashi <iga@ruby-lang.org>

  This program is free software.
  You can distribute/modify this program under
  the terms of the Ruby Distribute License.

=end

module RBBR
module UI
module GTK

  class ModuleDisplay < Gtk::VPaned
    
    def initialize(database)
      super()

      @database = database
      @docviewer = DocViewer.new(database)

      # create display paned
      display_box = Gtk::VBox.new(false, 0)
      add1(display_box)

      docviewer_scwin = Gtk::ScrolledWindow.new 
      docviewer_scwin.set_policy(Gtk::POLICY_AUTOMATIC, Gtk::POLICY_AUTOMATIC)
      add2(docviewer_scwin)
      docviewer_scwin.add(@docviewer)
      set_position(200)

      # create module label
      @module_label = ModuleLabel.new
      display_box.pack_start(@module_label, false, true, 0)

      # create notebook
      notebook = Gtk::Notebook.new
      notebook.set_tab_pos(Gtk::POS_TOP)
      notebook.set_scrollable(true)
      notebook.set_homogeneous(false)
      notebook.set_show_tabs(true)
      display_box.pack_start(notebook, true, true, 0)

      # create lists
      @lists = [ 
        [MethodList.new, "Methods"],
        [ConstantList.new, "Constants"],
        [PropertyList.new, "Properties"],
        [SignalList.new, "Signals"],
      ]
      @lists.each_with_index do |(list, label), index|
        scwin = Gtk::ScrolledWindow.new
        scwin.set_policy(Gtk::POLICY_AUTOMATIC, Gtk::POLICY_AUTOMATIC)
        scwin.add(list)
        notebook.append_page(scwin, Gtk::Label.new(label))
        notebook.set_tab_label_packing(scwin, true, true, Gtk::PACK_START)
        
        list.add_observer(@docviewer)
      end
	  
      @module_label.show
      display_box.show
      notebook.show_all
      @docviewer.show_all
      docviewer_scwin.show
    end

    def update(*args)
      @module_label.update(*args)
      @lists.each do |list, label|
        list.update(*args)
      end
      @docviewer.update(*args)
    end

  end
end;end;end
